/*
 * This file is part of the Alida-C++ library, an
 *
 * Advanced Library for Integrated Development of Data Analysis Applications.
 *
 * Copyright (C) 2012 - @YEAR@
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/*
 * Most recent change(s):
 *
 * $Rev: 101 $
 * $Date: 2012-03-12 09:47:11 +0100 (Mo, 12. Mär 2012) $
 * $Author: posch $
 *
 */

#ifndef NATIVE_DATATYPES_PROVIDER_H_INCLUDED
#define NATIVE_DATATYPES_PROVIDER_H_INCLUDED

#include "dataio/provider/cmdline/ALDDataIOCmdline.h"

namespace Alida {

/// Data I/O provider for C++ build-in native data types.
/**
 * Class for data I/O of native data types via commandline.
 * Supported native datatypes are
 * - double
 * - float
 * - int
 *
 */
class ALDNativeDatatypesDataIO : public ALDDataIOCmdline
{
 public:

	/// Default destructor.
	virtual ~ALDNativeDatatypesDataIO() {};

	/// Function to parse data objects from input strings.
	virtual void* readData(std::string input, std::string type) const;

	/// Function to transfer data into a suitable output string.
	virtual std::string
	writeData(std::string format, std::string type, void *data) const;
};

}

#endif /* NATIVE_DATATYPES_PROVIDER_H_INCLUDED */
