/*
 * This file is part of the Alida-C++ library, an
 *
 * Advanced Library for Integrated Development of Data Analysis Applications.
 *
 * Copyright (C) 2012 - @YEAR@
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/*
 * Most recent change(s):
 *
 * $Rev: 101 $
 * $Date: 2012-03-12 09:47:11 +0100 (Mo, 12. Mär 2012) $
 * $Author: posch $
 *
 */

#include <math.h>
#include <stdio.h>

#include <fstream>
#include <iostream>
#include <string>

#include "dataio/ALDDataIOManagerCmdline.h"
#include "dataio/provider/cmdline/ALDStringDataIO.h"

using namespace std;

using namespace Alida;

/**
 * \ingroup provider_registrations
 * Register provider for string data.
 */
REGISTER_PROVIDER(ALDStringDataIO,string,Cmdline);

/**
 * This function transfers the given input string into a string object.
 *
 * @param input		Input string to be processed.
 * @param	type		Identifier string for requested object type.
 * @return Read string.
 */
void* ALDStringDataIO::readData(string input, string type) const
{
	string *s = new string( input);
	return s;
}

/**
 * This function formats the given string for output on console.
 *
 * @param input		Input string to be put out.
 * @param	type		Identifier string for requested object type.
 * @param data		Data object to be converted to string representation.
 * @return Generated string.
 */
string ALDStringDataIO::writeData(string input, string type, void* data) const
{
	return string(input);
}
