/*
 * This file is part of the Alida-C++ library, an
 *
 * Advanced Library for Integrated Development of Data Analysis Applications.
 *
 * Copyright (C) 2012 - @YEAR@
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/*
 * Most recent change(s):
 *
 * $Rev: 101 $
 * $Date: 2012-03-12 09:47:11 +0100 (Mo, 12. Mär 2012) $
 * $Author: posch $
 *
 */

#ifndef DEMO_OPERATOR_H_INCLUDED
#define DEMO_OPERATOR_H_INCLUDED

#include "operator/ALDOperator.h"

#include <string>

using namespace Alida;

/// Simple demo operator.
/**
 * This operator class just demonstrates the built-in functionality of
 * Alida. It declares parameters of several native data types, however,
 * does not perform any serious manipulations on the data.
 */
class DemoOperator : public ALDOperator
{
 public:
  
	/// Default constructor.
  DemoOperator();

  /// Default destructor.
  virtual ~DemoOperator() {};

 public:

  /// Method to implement the operator's functionality.
  void operate();

  /// Operator specific validation of parameters
  void validateCustom();

};

#endif /* DEMO_OPERATOR_H_INCLUDED */
