/*
 * This file is part of the Alida-C++ library, an
 *
 * Advanced Library for Integrated Development of Data Analysis Applications.
 *
 * Copyright (C) 2012 - @YEAR@
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/*
 * Most recent change(s):
 *
 * $Rev: 101 $
 * $Date: 2012-03-12 09:47:11 +0100 (Mo, 12. Mär 2012) $
 * $Author: posch $
 *
 */

#ifndef OPENCV_IMAGE_PROVIDER_H_INCLUDED
#define OPENCV_IMAGE_PROVIDER_H_INCLUDED

#include <map>
#include <string>

#include "dataio/provider/cmdline/ALDDataIOCmdline.h"

namespace Alida {

/// Class for I/O of OpenCV images via command line.
/**
 * Here we demonstrate what needs to be done to add data I/O providers for
 * specific data types to the Alida framework.<br> In this case a provider for
 * the OpenCV image data type IplImage is defined used in conjunction with
 * the corresponding operator DemoOperatorOpenCV.
 */
class OpenCVImageDataIO : public ALDDataIOCmdline
{
 public:

	/// Default destructor.
	virtual ~OpenCVImageDataIO() {};

	/// Function to open an image from given filename.
	virtual void* readData(std::string, std::string) const;

	/// Function to output an image to file or screen.
	virtual std::string
	writeData(std::string format, std::string type, void* data) const;

};

}

#endif /* OPENCV_IMAGE_PROVIDER_H_INCLUDED */
