#ifndef EXCEPTION_H_INCLUDED
#define EXCEPTION_H_INCLUDED

#include <exception>
#include <iostream>

// ********************************************************************
// static file variables and defines / declarations
// ********************************************************************

namespace Alida
{

// ********************************************************************

/// Class for exceptions in Alida.
class ALDException : public  std::exception
{
 protected:

  /** \brief Name of class throwing the exception. */
  const std::string className;

  /** \brief Method inside class throwing the exception. */
  const std::string function;

  /** \brief Actual error message. */
  const std::string errorMsg;

 public:
  
  /** \brief Default constructor. */
  ALDException(std::string c,
		 std::string f,
		 std::string e) :
    className( c), function( f), errorMsg( e){
  };

  /** \brief Default destructor. */
  virtual ~ALDException() throw() {};
  
  /** \brief Prints exception message to standard out. */
  void printMsg() {
    std::cerr << className << "::" << function 
	      << " - " << errorMsg << std::endl;
  };
};

}

// ********************************************************************

#endif // EXCEPTION_H_INCLUDED
