/*
 * This file is part of Alida-C++ library for
 *
 * Advanced Library for Integrated Development of Data Analysis Applications.
 *
 * Copyright (C) 2012 - @YEAR@
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/*
 * Most recent change(s):
 *
 * $Rev: 47 $
 * $Date: 2012/03/06 20:50:22 $
 * $Author: posch $
 *
 */

#include <string>

#include "operator/ALDOpParameterDescriptor.h"

using namespace std;

using namespace Alida;

/**
 * @param _name					Name of the parameter.
 * @param	_typeIdStr		Type identifier string.
 * @param	_typeNiceName	User-readable name of parameter type.
 * @param _direction		Direction of the parameter.
 * @param	_required			Flag to declare parameter required.
 * @param _supplemental	Flag to declare parameter supplemental.
 * @param _label				Label for the parameter (e.g. for GUIs).
 * @param _explanation	Description for the parameter.
 * @param _defaultValue	Default value.
 */
ALDOpParameterDescriptor::ALDOpParameterDescriptor( std::string _name,
		std::string _typeIdStr, std::string _typeNiceName,
	ALDParameterDirection _direction, 
	bool _required, bool _supplemental, 
	std::string _label, std::string _explanation, void* _defaultValue) : 

	name(_name),
	typeIdStr( _typeIdStr),
	typeNiceName( _typeNiceName),
	direction( _direction),
	required( _required),
	supplemental( _supplemental),
	label( _label),
	explanation( _explanation),
	defaultValue( _defaultValue) {

	value = NULL;
}

